Unit Dialogs;

Interface

Function SelectFile(Var FileName:string):boolean;

Implementation

uses
 VGA,DOS,
 Keyboard;

Var
 Path:string;

Type
 pFile=^TFile;
 TFile=record
  Name:string;
  Next:pFile;
  Prev:pFile;
 end;

Function SelectFile(Var FileName:string):boolean;
 const
  top =40;
  width=150;
  left=(360-width) div 2;
  height=145;
 Var
  Files:pFile;
  AFile:pFile;
  LFile:pFile;
  ff:SearchRec;
  y :word;
  ly:word;
  k :byte;

  select:string;


 procedure DrawList;
  var
   AFile:pFile;
  begin
   Box(left+3,top+14,width-6,height-27,clWhite);
   ly:=Top+15;
   AFile:=LFile;
   while (AFile<>nil)and(ly<Top+Height-15) do begin
    OutTextXY(Left+4,ly,clBlack,AFile^.Name);
    inc(ly,9);
    AFile:=AFile^.Next;
   end;
  end;

 procedure AddItem(Item:string);
  var
   a,b:pFile;
  begin
   New(AFile);
   AFile^.Name:=Item;
   a:=Files;
   b:=nil;
   while (a<>nil)and(a^.Name<Item) do begin
    b:=a;
    a:=a^.Next;
   end;
   AFile^.Next:=a; if a<>nil then a^.Prev:=AFile;
   AFile^.Prev:=b; if b<>nil then b^.Next:=AFile else Files:=AFile;
   if Files=nil then Files:=AFile;
  end;

 begin
  SelectFile:=False;

{  SelectPage(1); }

  Frame3D(left,top,width,height,clWhite,clBlue,clLightBlue);
  Box(left+2,top+2,width-4,10,clBlue);
  OutTextXY(left+3,top+3,clWhite,'Select a D64 file');
  Frame3D(left+2,top+13,width-4,height-25,clLightGrey,clGrey,clWhite);
  OutTextXY(LefT+2,Top+Height-10,clBlue,'Enter / Esc');

  select:='';

  repeat

  Files:=nil;
  LFile:=nil;

  FindFirst(Path+'\*.*',Directory,ff);
  while DOSError=0 do begin
   if (ff.Attr and Directory>0)and(ff.Name<>'.') then AddItem('/'+ff.Name);
   FindNext(ff);
  end;

  FindFirst(Path+'\*.D64',AnyFile,ff);
  while DOSError=0 do begin
   AddItem(ff.Name);
   FindNext(ff);
  end;

  LFile:=Files;

  if Select<>'' then begin
   While (LFile<>nil)and(LFile^.Name<>Select) do LFile:=LFile^.Next;
   if LFile=nil then LFile:=Files;
  end;

  DrawList;

  y:=Top+15;
  AFile:=LFile;

  repeat

   OutTextXY(Left+4,y,clGreen,AFile^.Name);

   k:=getkey;
   case k of
    key_up : begin
            if AFile^.Prev<>nil then begin
             OutTextXY(LefT+4,y,clBlack,AFile^.Name);
             AFile:=AFile^.Prev;
             if y>Top+15 then
              dec(y,9)
             else begin
              LFile:=LFile^.Prev;
              DrawList;
             end;
            end;
           end;
    key_down : begin
            if AFile^.Next<>nil then begin
             OutTextXY(LefT+4,y,clBlack,AFile^.Name);
             AFile:=AFile^.Next;
             if y<Top+15+12*9 then
              inc(y,9)
             else begin
              LFile:=LFile^.Next;
              DrawList;
             end;
            end;
           end;
   end;

  until (k=key_escape)or(k=key_return);

  if k=key_return then begin
   if AFile^.Name[1]='/' then begin
    if AFile^.Name[2]='.' then begin
     Select:=Path;
     y:=Length(Select);
     while Select[y]<>'\' do dec(y);
     Path[0]:=chr(y-1);
     Delete(Select,1,y-1);
     Select[1]:='/';
    end else begin
     AFile^.Name[1]:='\';
     Path:=Path+AFile^.Name;
    end;
   end else begin
    FileName:=Path+'\'+AFile^.Name+#0;
    SelectFile:=True;
    k:=key_escape;
   end;
  end;

  LFile:=Files;
  While LFile<>nil do begin
   AFile:=LFile^.Next;
   Dispose(LFile);
   LFile:=AFile;
  end;

  until k=key_escape;

{  SelectPage(0); }
 end;

begin
 GetDir(0,Path);
end.