Program CBM64_Emulator_v2;

(*
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

{ this new version is based on Frodo :)
  this is a LineBased emulator with real keyboard mapping (French AZERTY)

  to speed up the emulator :

   Include(P,CFg) is now P:=P+[Cfg]

   Case IR of
    $00:
    $01:
    ...
   end;

   use now a jump table (CPU.ASM)

   have fun !
}

{$I CBMOPT.PAS}

Uses
 MEMORY,   { Define general peek & poke }
 HALTCODE, { Error Handler }
 TOOLS,    { HexaB, File I/O ... }
 Keyboard, { Both INT 09 Handler or INT 16 Keyboard }
 CPU,VIC,CIA,IEC
{ ,DEBUG};

var
 viccycles:integer;

{ Entry point : }

Begin
 { Call RESET }
 VIC.Reset;
 CIA.Reset;
 PC:=$FCE2; { C=64 Entry point }
{ Start Emulator }
 InstallKeyboard;
 Cycles:=0;
 TotalCycles:=0;
 Time  :=ticks;
 repeat
  inc(totalcycles,64);
  vicCycles:=DrawLine;
  inc(Cycles,vicCycles);
  CIA.EmulateLine(64);
  if CIANMI then begin
   CIANMI:=False;
   Pushw(PC);
   Push(byte(P));
   P:=P+[IFg];{Include(P,IFg);}
   PC:=PeekW($FFFA);
   dec(Cycles,7);
   inc(totalcycles,7);
  end else
  if (CIAIRQ or VICIRQ) and (Not (IFg in P)) then begin
    CheckKeyboard; { avoid lost keys (use an internal keyboard buffer) }
    CIAIRQ:=False;
    VICIRQ:=False;
    PushW(PC);
    Push(byte(P));
    P:=P+[IFg];{Include(P,IFg);}
    PC:=PeekW($FFFE);
    dec(Cycles,7);
    inc(totalcycles,7);
  end;
  Run;  { Fetch opcodes for "Cycles" cycles }
 until Done;
 RemoveKeyboard;
 halt(hESC);
End.
